package at.leonding.cooldroid

import android.support.v7.app.AppCompatActivity
import android.os.Bundle
import android.util.Log
import kotlinx.android.synthetic.main.activity_main.*

class MainActivity : AppCompatActivity() {

    companion object{
        val COUNTER = "counter"
        val LOG_TAG = MainActivity::class.java.simpleName
    }

    private var counter = 0

    private fun  getMessageText() =
        when (counter) {
            0 -> getString(R.string.txt_dont_touch)
            1 -> getString(R.string.txt_once)
            2 -> getString(R.string.txt_twice)
            else -> getString(R.string.txt_multi, counter)
        }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)
        if (savedInstanceState != null) {
            counter = savedInstanceState.getInt(COUNTER);
            textView.text = getMessageText()
        }
        imageView.setOnClickListener {
            counter++
            Log.d(LOG_TAG, "onClick(), counter: ${counter}")
            textView.text = getMessageText()
        }
    }

    override fun onSaveInstanceState(outState: Bundle?) {
        outState?.putInt(COUNTER, counter)
        Log.d(LOG_TAG, "onSaveInstanceState(), counter: ${counter}")
        super.onSaveInstanceState(outState)
    }
}
