package at.htl.payyours

import android.app.Application
import android.content.Context
import android.util.Log
import androidx.lifecycle.AndroidViewModel
import androidx.lifecycle.LiveData
import androidx.lifecycle.MutableLiveData
import androidx.lifecycle.ViewModel

class MainActivityViewModel(application: Application) : AndroidViewModel(application){
    companion object {
        val TAG = MainActivityViewModel::class.java.simpleName
    }
    private val _payment = MutableLiveData<Payment>()
    init{
        _payment.value =
            SettingsActivity.defaultPayment(application.getSharedPreferences(
                SettingsActivity.PREFERENCE_FILENAME, Context.MODE_PRIVATE))
    }
    val payment: MutableLiveData<Payment>
        get() = _payment

    override fun onCleared() {
        Log.d(TAG, "onCleared(): $_payment")
        super.onCleared()
    }

}