package at.htl.payyours

import android.app.Activity
import android.content.Intent
import android.os.Bundle
import android.util.Log
import android.view.Menu
import android.view.MenuItem
import androidx.appcompat.app.AppCompatActivity
import androidx.databinding.DataBindingUtil
import androidx.lifecycle.LifecycleOwner
import androidx.lifecycle.ViewModelProviders


class MainActivity : AppCompatActivity(), LifecycleOwner {

    companion object {
        val TAG = MainActivity::class.java.simpleName
        val REQUEST_SETTINGS = 1
    }

    private lateinit var model: MainActivityViewModel
    private val payment: Payment get(){
        return model.payment.value!!
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        Log.d(TAG, "onCreate()")
        super.onCreate(savedInstanceState)

        model = ViewModelProviders.of(this).get(MainActivityViewModel::class.java)

        val binding : at.htl.payyours.databinding.ActivityMainBinding = DataBindingUtil.setContentView(this, R.layout.activity_main)
        binding.lifecycleOwner = this
        binding.model = model
    }

    override fun onCreateOptionsMenu(menu: Menu?): Boolean {
        menuInflater.inflate(R.menu.menu_main, menu)
        return super.onCreateOptionsMenu(menu)
    }

    override fun onOptionsItemSelected(item: MenuItem?) =
        when (item?.itemId) {
            R.id.menu_item_quit -> {
                finish()
                true
            }
            R.id.menu_item_settings -> {
                Log.d("MainActivity", "Settings menu called")
                startActivityForResult(Intent(this, SettingsActivity::class.java), REQUEST_SETTINGS)
                true
            }
            else -> super.onOptionsItemSelected(item)
        }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        if (requestCode == REQUEST_SETTINGS && resultCode == Activity.RESULT_OK){
            model.onUpdatePricePerUnit()
        }
    }

}
