package at.htlleonding.meettheteacher

import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import kotlinx.android.synthetic.main.teacher_card.view.*

class TeachersAdapter(private val teachers: List<Teacher>)
            : RecyclerView.Adapter<TeachersAdapter.TeacherViewHolder>() {

    class TeacherViewHolder(val card: View) : RecyclerView.ViewHolder(card)

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): TeacherViewHolder {
        val view = LayoutInflater.from(parent.context)
            .inflate(R.layout.teacher_card, parent, false)
        return TeacherViewHolder(view)
    }

    override fun getItemCount() = teachers.size

    override fun onBindViewHolder(holder: TeacherViewHolder, position: Int) {
        val teacher = teachers[position]
        with(holder.card){
            tvName.text = teacher.name
            tvDay.text = teacher.day
            tvTime.text = teacher.time
            tvRoom.text = teacher.room
            imageView.setImageResource(teacher.imageUri)

        }
    }

}


