package at.htlleonding.meettheteacher

import android.graphics.Bitmap
import android.graphics.BitmapFactory
import android.os.AsyncTask
import android.util.Log
import java.net.HttpURLConnection
import java.net.URL

class LoadTeacherImageAsyncTask(private val resultCallback: (Bitmap?) -> Unit)
        : AsyncTask<Teacher, Void, Bitmap?>(){

    companion object{
        val LOG_TAG = LoadTeacherImageAsyncTask::class.java.simpleName
        val BASE_URL = "http://vm96.htl-leonding.ac.at/wordpress/wp-content/uploads/lehrer-innen/"
    }

    override fun doInBackground(vararg teachers: Teacher): Bitmap? {

        try{
            val teacher = teachers[0]
            val name = teacher.name.toLowerCase().replace("ü", "ue")
                .replace("ö", "oe")
                .replace("ä", "ae")
                .replace("ß", "ss")
                .split(' ')

            val imageName = name[1].get(0) + "." + name[0] + ".jpg"

            val url = URL(BASE_URL + imageName)
            teacher.imageUri = try {
                val httpURLConnection = url.openConnection() as HttpURLConnection
                BitmapFactory.decodeStream(httpURLConnection.inputStream)
            }catch (e: Exception){
                Log.e(LOG_TAG, "Image file not found: " + url)
                null
            }
            return teacher.imageUri

        } catch (e: Exception) {
            Log.e(LOG_TAG, "doInBackground(), exception: " + e.message)
            e.printStackTrace()
        }

        return null
    }

    override fun onPostExecute(result: Bitmap?) {
        super.onPostExecute(result)
        resultCallback(result)
    }

}