package at.htlleonding.meettheteacher

import android.os.AsyncTask
import android.util.Log
import org.jsoup.Jsoup
import java.io.InputStreamReader
import java.net.HttpURLConnection
import java.net.URL

class LoadTeachersAsyncTask(private val resultCallback: (List<Teacher>) -> Unit)
        : AsyncTask<String, Void, List<Teacher>>(){

    companion object{
        val LOG_TAG = LoadTeachersAsyncTask::class.java.simpleName
    }

    override fun doInBackground(vararg params: String): List<Teacher> {

        val url = URL(params[0])
        val httpURLConnection = url.openConnection() as HttpURLConnection
        //httpURLConnection.setRequestProperty("User-Agent", "Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.11 (KHTML, like Gecko) Chrome/23.0.1271.95 Safari/537.11")
        val inputStreamReader = InputStreamReader(httpURLConnection.inputStream)
        val lines = inputStreamReader.readLines()

        val teachers = mutableListOf<Teacher>()

        Jsoup.connect(params[0]).get().run {
            val table = select("table[class=\"tablepress sprechstunden\"]")
            val rows = table.select("tr")
            rows.forEachIndexed { index, element ->
                if (index > 1){
                    val cols = element.select("td")
                    var name = ""
                    var day = ""
                    var time = ""
                    var location = ""
                    cols.forEachIndexed { i, col ->
                        when (i){
                            0 -> name = col.text()
                            1 -> day = col.text()
                            3 -> time = col.text()
                            4 -> location = col.text()
                        }
                        Log.d(LOG_TAG, "td = " + i + ": " + col.text())
                    }
                    teachers.add(Teacher(name, day, time, location, 0, null))
                }
            }
        }
        return teachers
    }

    override fun onPostExecute(result: List<Teacher>) {
        super.onPostExecute(result)
        resultCallback(result)
    }

}