package at.htlleonding.meettheteacher

import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.util.Log
import androidx.recyclerview.widget.LinearLayoutManager
import kotlinx.android.synthetic.main.activity_main.*

class MainActivity : AppCompatActivity() {
    companion object{
        val LOG_TAG = MainActivity::class.java.simpleName
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)
        rvTeachers.layoutManager = LinearLayoutManager(this)
        rvTeachers.hasFixedSize()
        val loadTeachersAsyncTask = LoadTeachersAsyncTask{
            Log.d(LOG_TAG, "Async task finished")
            rvTeachers.adapter = TeachersAdapter(it)
        }
        try{
            loadTeachersAsyncTask.execute("https://www.htl-leonding.at/kontakt/lehrer-innen/")
            Log.d(LOG_TAG, "Async task started")
        }
        catch(e: Exception){
            Log.e(LOG_TAG, "Loading teachers failed: " + e.message)
        }
    }
}
