package at.htl.boehm.meettheteacher

import android.os.Bundle
import android.support.v7.app.AppCompatActivity
import android.view.Menu
import android.view.MenuItem
import at.htl.boehm.meettheteacher.fragments.DisplayTeachersFragment
import at.htl.boehm.meettheteacher.fragments.DownloadTeachersFragment

class MainActivity : AppCompatActivity() {
    internal val LOG_TAG = MainActivity::class.java.simpleName

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)

        val displayTeachersFragment: DisplayTeachersFragment = DisplayTeachersFragment()
        supportFragmentManager.beginTransaction().replace(R.id.fl_main, displayTeachersFragment).commit()
    }

    override fun onCreateOptionsMenu(menu: Menu?): Boolean {
        menuInflater.inflate(R.menu.menu_main, menu)
        return super.onCreateOptionsMenu(menu)
    }

    override fun onOptionsItemSelected(item: MenuItem)= when(item.itemId) {
        R.id.menu_download -> {
            val downloadTeachersFragment: DownloadTeachersFragment = DownloadTeachersFragment()
            supportFragmentManager.beginTransaction().replace(R.id.fl_main, downloadTeachersFragment).commit()
            true
        }
        else -> super.onOptionsItemSelected(item)
    }
}
