package at.htl.boehm.meettheteacher.adapter

import android.graphics.BitmapFactory
import android.support.v7.widget.RecyclerView
import android.util.Log
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import at.htl.boehm.meettheteacher.R
import kotlinx.android.synthetic.main.teacher_card.view.*
import at.htl.boehm.meettheteacher.db.entities.Teacher

class TeachersAdapter(val teachers: List<Teacher>) : RecyclerView.Adapter<TeachersAdapter.TeacherViewHolder>() {
    internal val LOG_TAG = TeachersAdapter::class.java.simpleName

    class TeacherViewHolder(val card: View): RecyclerView.ViewHolder(card) {}

    override fun getItemCount() = teachers.size

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): TeacherViewHolder {
        val view = LayoutInflater.from(parent.context)
                .inflate(R.layout.teacher_card, parent, false)
        val viewHolder = TeacherViewHolder(view)
        Log.d(LOG_TAG, "onCreateViewHolder(): ${viewHolder.hashCode()}")

        return viewHolder
    }

    override fun onBindViewHolder(holder: TeacherViewHolder, position: Int) {
        val teacher = teachers[position]
        holder.itemView.cv_teacher.tv_name.text = teacher.name
        holder.itemView.cv_teacher.tv_day.text = teacher.day
        holder.itemView.cv_teacher.tv_time.text = teacher.time
        holder.itemView.cv_teacher.tv_room.text = teacher.room
        holder.itemView.cv_teacher.iv_teacher
                .setImageBitmap( BitmapFactory.decodeByteArray(teacher.bitmap,0, teacher.bitmap!!.size))
    }
}
