package at.htl.boehm.meettheteacher.asyncTasks

import android.os.AsyncTask
import android.util.Log
import at.htl.boehm.meettheteacher.db.entities.Teacher
import org.jsoup.Jsoup

class LoadTeachersAsyncTask(private val resultCallback: (List<Teacher>) -> Unit)
    : AsyncTask<String, Void, List<Teacher>>(){
    internal val LOG_TAG = LoadTeachersAsyncTask::class.java.simpleName

    override fun doInBackground(vararg urls: String): List<Teacher> {
        val url = urls[0]
        val teachers = ArrayList<Teacher>()
        Log.d(LOG_TAG, url)
        Jsoup.connect(url).get().run {
            select("tr").forEachIndexed { index, element ->
                if(index > 0){
                    val teacher: Teacher = Teacher()
                    element.select("td").forEachIndexed { index, element ->
                        when(index){
                            0 -> teacher.name = element.text()
                            1 -> teacher.day = element.text()
                            2 -> teacher.time = element.text()
                            3 -> teacher.room = element.text()
                        }
                    }
                    teachers.add(teacher)
                }
            }
        }
        return teachers
    }

    override fun onPostExecute(teachers: List<Teacher>) {
        super.onPostExecute(teachers)
        resultCallback(teachers)
    }
}