package at.htl.boehm.meettheteacher.asyncTasks

import android.graphics.Bitmap
import android.graphics.BitmapFactory
import android.os.AsyncTask
import android.util.Log
import at.htl.boehm.meettheteacher.db.entities.Teacher
import org.jsoup.Jsoup
import java.io.ByteArrayOutputStream
import java.io.FileNotFoundException
import java.net.HttpURLConnection
import java.net.URL

class LoadTeachersImageAsyncTask(private val resultCallback: (Teacher) -> Unit) : AsyncTask<Teacher, Void, Teacher>(){
    internal val LOG_TAG = LoadTeachersAsyncTask::class.java.simpleName

    override fun doInBackground(vararg teachers: Teacher): Teacher {
        val teacher = teachers[0]
        val detailsUrl = "http://www.htl-leonding.at/index.php?id=${teacher.detailsId}"
        var pictureUrl = ""
        Jsoup.connect(detailsUrl).get().run {
            pictureUrl = select("td").select("img").attr("src")
            Log.d(LOG_TAG, pictureUrl)
        }

        val imageUrl = URL("http://www.htl-leonding.at/$pictureUrl")
        try{
            val httpImageUrlConnection = imageUrl.openConnection() as HttpURLConnection
            teacher.bitmap = toByteArray(BitmapFactory.decodeStream(httpImageUrlConnection.inputStream))
        }catch (fnf: FileNotFoundException){
            val imageUrlAnonym = URL("http://www.htl-leonding.at/uploads/anonym.jpg")
            try{
                val httpImageUrlConnection = imageUrlAnonym.openConnection() as HttpURLConnection
                teacher.bitmap = toByteArray(BitmapFactory.decodeStream(httpImageUrlConnection.inputStream))
            }catch (e: Exception){
                e.printStackTrace()
            }
        }catch (e: Exception){
            e.printStackTrace()
            Log.e(LOG_TAG, "LoadTeachersImageAsyncTask, doInBackground, exception: ${e.message}")
        }
        return teacher
    }

    override fun onPostExecute(teacher: Teacher) {
        super.onPostExecute(teacher)
        resultCallback(teacher)
    }

    private fun toByteArray(bitmap: Bitmap?): ByteArray {
        val stream = ByteArrayOutputStream()
        bitmap?.compress(Bitmap.CompressFormat.PNG, 0, stream)
        return stream.toByteArray()
    }

}
