package at.htl.boehm.meettheteacher.db

import android.arch.persistence.room.Database
import android.arch.persistence.room.Room
import android.arch.persistence.room.RoomDatabase
import android.content.Context
import at.htl.boehm.meettheteacher.db.dao.TeacherDao
import at.htl.boehm.meettheteacher.db.entities.Teacher

@Database(entities = [(Teacher::class)], version = 10)
abstract class TeacherDatabase: RoomDatabase() {

    abstract fun teacherDao(): TeacherDao

    companion object {
        private var INSTANCE: TeacherDatabase? = null

        fun getInstance(context: Context?): TeacherDatabase? {
            if (INSTANCE == null) {
                synchronized(TeacherDatabase::class) {
                    if (context != null) {
                        INSTANCE = Room.databaseBuilder(context,
                                TeacherDatabase::class.java, "meettheteacher.db")
                                .build()
                    }
                }
            }
            return INSTANCE
        }

        fun destroyInstance() {
            INSTANCE = null
        }
    }
}