package at.htlleonding.room.notekeeper

import android.arch.lifecycle.Observer
import android.arch.lifecycle.ViewModelProviders
import android.content.Intent
import android.os.Bundle
import android.support.v7.app.AppCompatActivity
import android.support.v7.widget.LinearLayoutManager
import android.widget.Toast
import at.htlleonding.room.notekeeper.model.NoteViewModel
import kotlinx.android.synthetic.main.activity_main.*
import kotlinx.android.synthetic.main.content_main.*

class MainActivity : AppCompatActivity() {

    companion object{
        val LOG_TAG = MainActivity::class.java.simpleName
    }

    private lateinit var noteViewModel: NoteViewModel

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)
        setSupportActionBar(toolbar)
        noteViewModel = ViewModelProviders.of(this).get(NoteViewModel::class.java)
        val noteListAdapter = NoteListAdapter()
        recyclerview.adapter = noteListAdapter
        recyclerview.layoutManager = LinearLayoutManager(this)
 	    noteViewModel.notes.observe(this, Observer { notes ->
            notes?.let {
                noteListAdapter.setNotes(notes)
            }
        })
        fab.setOnClickListener { _ ->

            Toast.makeText(
                applicationContext,
                "Button clicked",
                Toast.LENGTH_LONG
            ).show()
        }
    }
}
