package at.htlleonding.room.notekeeper

import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import at.htlleonding.room.notekeeper.model.Note
import kotlinx.android.synthetic.main.list_item.view.*

class NoteListAdapter()
    : RecyclerView.Adapter<NoteListAdapter.NoteViewHolder>() {

    private var noteList : List<Note> = mutableListOf()

    override fun onCreateViewHolder(parent: ViewGroup, pos: Int): NoteViewHolder {
        val view = LayoutInflater.from(parent.context)
            .inflate(R.layout.list_item, parent, false)
        return NoteViewHolder(view)
    }

    override fun getItemCount() = noteList.size

    override fun onBindViewHolder(viewHolder: NoteViewHolder, position: Int) {
        viewHolder.card.txvNote.text = noteList[position].note
    }

    fun setNotes(notes: List<Note>) {
        noteList = notes
        notifyDataSetChanged()
    }

    class NoteViewHolder(var card: View) : RecyclerView.ViewHolder(card) {
    }
}


