package at.htlleonding.room.notekeeper

import android.app.Activity
import android.content.Intent
import android.support.v7.app.AppCompatActivity
import android.os.Bundle
import android.text.TextUtils
import kotlinx.android.synthetic.main.activity_new.*

class UpdateNoteActivity : AppCompatActivity() {
    companion object{
        val NOTE_PREVIOUS = "NOTE_PREVIOUS"
        val NOTE_NEW = "NOTE_NEW"
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_new)

        val previous = intent.extras?.getString(NOTE_PREVIOUS)
        etNote.setText(previous)
        bSave.setOnClickListener {
            if (TextUtils.isEmpty(etNote.text))
                setResult(Activity.RESULT_CANCELED)
            else {
                val resultIntent = Intent()
                resultIntent.putExtra(UpdateNoteActivity.NOTE_PREVIOUS, previous)
                resultIntent.putExtra(UpdateNoteActivity.NOTE_NEW, etNote.text.toString())
                setResult(Activity.RESULT_OK, resultIntent)
            }
            finish()
        }
        bCancel.setOnClickListener {
            setResult(Activity.RESULT_CANCELED)
            finish()
        }

    }
}
