package at.htlleonding.room.notekeeper.model

import android.app.Application
import android.arch.lifecycle.AndroidViewModel
import android.arch.lifecycle.LiveData
import android.arch.lifecycle.MutableLiveData
import android.util.Log


class NoteViewModel(application: Application) : AndroidViewModel(application) {

    companion object{
        val LOG_TAG = NoteViewModel::class.java.simpleName
    }

    private var _notes = MutableLiveData<List<Note>>()
    val notes: LiveData<List<Note>>
        get() = _notes

    init{
        _notes.value = mutableListOf(Note("a"), Note("b"))
    }


    fun add(note: Note) {
        val list = _notes.value?.toMutableList()
        list?.add(note)
        _notes.value = list
    }

    fun delete(note: Note){
        val list = _notes.value?.toMutableList()
        list?.remove(note)
        _notes.value = list
    }

    fun update(previous: String, new: String) {
        val list = _notes.value
        val item = list?.find{ it.note == previous}
        item?.note = new
        _notes.value = list
    }

}