package at.htlleonding.room.notekeeper.db

import android.arch.persistence.room.Database
import android.arch.persistence.room.Room
import android.arch.persistence.room.RoomDatabase
import android.content.Context
import at.htlleonding.room.notekeeper.model.Note

@Database(entities = [Note::class], version = 1, exportSchema = false)
abstract class NotesRoomDatabase : RoomDatabase() {

    abstract fun notesDao(): NotesDao

    companion object {

        @Volatile
        private var instance: NotesRoomDatabase? = null

        fun getInstance(context: Context): NotesRoomDatabase {
            synchronized(this) {
                var temp = instance
                if (temp == null) {
                    temp = Room.databaseBuilder(
                        context.applicationContext,
                        NotesRoomDatabase::class.java, "notes_database"
                    )
                        .fallbackToDestructiveMigration()
                        .build()
                    instance = temp
                }
                return temp
            }
        }
    }
}