package at.htl.paging

import android.os.Bundle
import android.widget.Toast
import androidx.appcompat.app.AppCompatActivity
import at.htl.paging.api.GitRepoService
import at.htl.paging.api.GitRepoServiceBuilder
import at.htl.paging.api.GitRepoResponse
import at.htl.paging.R
import retrofit2.Call
import retrofit2.Callback
import retrofit2.Response

class MainActivity : AppCompatActivity() {

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)

        val service = GitRepoServiceBuilder.getGitRepoService()
        val call = service.getRepositories(1, 20, "android")

        call.enqueue(object: Callback<GitRepoResponse> {

            override fun onResponse(call: Call<GitRepoResponse>, response: Response<GitRepoResponse>) {

                if (response.isSuccessful) {
                    val apiResponse = response.body()!!
                    val responseItems = apiResponse.items

                    val size = responseItems?.let {
                        responseItems.size.toString()
                    }

                    Toast.makeText(this@MainActivity, size, Toast.LENGTH_LONG).show()
                }
            }

            override fun onFailure(call: Call<GitRepoResponse>, t: Throwable) {
            }
        })
    }
}
