package at.htl.paging

import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import at.htl.paging.api.GitRepo
import kotlinx.android.synthetic.main.list_item.view.*

class GitRepoListAdapter : RecyclerView.Adapter<GitRepoListAdapter.GitRepoViewHolder>() {



    var items : List<GitRepo> = listOf()
        set(value){
            field = value
            notifyDataSetChanged()
        }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): GitRepoViewHolder {
        val view = LayoutInflater.from(parent.context).inflate(R.layout.list_item,parent, false)
        return GitRepoViewHolder(view)
    }

    override fun getItemCount(): Int {
        return items.size
    }

    override fun onBindViewHolder(holder: GitRepoViewHolder, position: Int) {
        with(holder.view){
            val repo = items[position]
            repo_name.text = repo.fullName
            repo_language.text = repo.language
            repo_description.text = repo.description
            repo_forks.text = repo.forks.toString()
            repo_stars.text = repo.stars.toString()

        }
    }

    class GitRepoViewHolder(val view: View) : RecyclerView.ViewHolder(view){

    }

}
