package at.htl.paging

import android.widget.Toast
import androidx.lifecycle.LiveData
import androidx.lifecycle.MutableLiveData
import androidx.lifecycle.ViewModel
import at.htl.paging.api.GitRepo
import at.htl.paging.api.GitRepoResponse
import at.htl.paging.api.GitRepoServiceBuilder
import retrofit2.Call
import retrofit2.Callback
import retrofit2.Response

class GitRepoListViewModel : ViewModel() {

    private var _gitRepoList  = MutableLiveData<List<GitRepo>>()
    val gitRepoList: LiveData<List<GitRepo>> = _gitRepoList
    init{
        val service = GitRepoServiceBuilder.getGitRepoService()
        val call = service.getRepositories(1, 200, "android")

        call.enqueue(object: Callback<GitRepoResponse> {

            override fun onResponse(call: Call<GitRepoResponse>, response: Response<GitRepoResponse>) {

                if (response.isSuccessful) {
                    val apiResponse = response.body()!!
                    val responseItems = apiResponse.items

                    responseItems?.let {
                        _gitRepoList.value = it
                    }


                }
            }

            override fun onFailure(call: Call<GitRepoResponse>, t: Throwable) {
            }
        })
    }

}