package at.htl.paging

import android.annotation.SuppressLint
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.paging.PagedListAdapter
import androidx.recyclerview.widget.DiffUtil
import androidx.recyclerview.widget.RecyclerView
import at.htl.paging.api.GitRepo
import kotlinx.android.synthetic.main.list_item.view.*

class GitRepoListAdapter : PagedListAdapter<GitRepo,GitRepoListAdapter.GitRepoViewHolder>(REPO_COMPARATOR) {
    companion object{
        private val REPO_COMPARATOR = object  : DiffUtil.ItemCallback<GitRepo> (){
            override fun areItemsTheSame(oldItem: GitRepo, newItem: GitRepo): Boolean {
                return oldItem.fullName == newItem.fullName
            }

            @SuppressLint("DiffUtilEquals")
            override fun areContentsTheSame(oldItem: GitRepo, newItem: GitRepo): Boolean {
                return oldItem == newItem
            }

        }

    }


    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): GitRepoViewHolder {
        val view = LayoutInflater.from(parent.context).inflate(R.layout.list_item,parent, false)
        return GitRepoViewHolder(view)
    }


    override fun onBindViewHolder(holder: GitRepoViewHolder, position: Int) {
        val repo = getItem(position)
        repo?.let{
            with(holder.view){
                repo_name.text = repo.fullName
                repo_description.text = repo.description
                repo_forks.text = repo.forks.toString()
                repo_stars.text = repo.stars.toString()
            }
        }
    }

    class GitRepoViewHolder(val view: View) : RecyclerView.ViewHolder(view){

    }

}
