package at.htl.paging

import androidx.lifecycle.LiveData
import androidx.lifecycle.ViewModel
import androidx.paging.LivePagedListBuilder
import androidx.paging.PagedList
import at.htl.paging.api.GitRepo
import at.htl.paging.repository.GitRepoDataSource
import at.htl.paging.repository.GitRepoDataSourceFactory

class GitRepoListViewModel : ViewModel() {

    //private var _gitRepoDataSource :  LiveData<GitRepoDataSource>
    var gitRepoList: LiveData<PagedList<GitRepo>>
    init{
        val itemPagedDataSourceFactory = GitRepoDataSourceFactory()
        //_gitRepoDataSource = itemPagedDataSourceFactory.gitRepoDataSource
        val config = PagedList.Config.Builder()
            .setEnablePlaceholders(false)
            .setPageSize(GitRepoDataSource.PAGE_SIZE)
            .build()
        gitRepoList = LivePagedListBuilder(itemPagedDataSourceFactory, config)
            .build()
    }

}