package at.htl.paging

import android.os.Bundle
import android.util.Log
import android.widget.LinearLayout
import android.widget.Toast
import androidx.appcompat.app.AppCompatActivity
import androidx.lifecycle.Observer
import androidx.lifecycle.ViewModelProviders
import androidx.recyclerview.widget.LinearLayoutManager
import at.htl.paging.api.GitRepoService
import at.htl.paging.api.GitRepoServiceBuilder
import at.htl.paging.api.GitRepoResponse
import at.htl.paging.R
import kotlinx.android.synthetic.main.activity_main.*
import retrofit2.Call
import retrofit2.Callback
import retrofit2.Response

class MainActivity : AppCompatActivity() {
    companion object{
        val LOG_TAG = MainActivity::class.java.simpleName
    }

    lateinit var model: GitRepoListViewModel

    val startTime = System.currentTimeMillis()

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)
        recyclerView.layoutManager = LinearLayoutManager(this)
        val adapter = GitRepoListAdapter()

        model = ViewModelProviders.of(this).get(GitRepoListViewModel::class.java)
        model.gitRepoList.observe(this, Observer{
            it?.let{
                val stopTime = System.currentTimeMillis()
                val message = "${(stopTime - startTime)} ms for loading ${it.size} items"
                Log.d(LOG_TAG, message)
                adapter.submitList(it)
                Toast.makeText(this, message, Toast.LENGTH_LONG).show()
            }


        })
        recyclerView.adapter = adapter


    }
}
