package at.htl.leonding.swimresults.database

import android.content.Context
import androidx.room.Database
import androidx.room.Room
import androidx.room.RoomDatabase

@Database(entities = [Swimmer::class], version = 1, exportSchema = false)
abstract class SwimResultsDatabase : RoomDatabase() {

    abstract fun swimResultsDao(): SwimResultsDao

    companion object {
        @Volatile
        private var INSTANCE: SwimResultsDatabase? = null
        fun getInstance(context: Context): SwimResultsDatabase {

            synchronized(this) {

                var instance = INSTANCE
                if (instance == null) {
                    instance = Room.databaseBuilder(
                            context.applicationContext,
                            SwimResultsDatabase::class.java,
                            "swim_results_database"
                    )
                             .fallbackToDestructiveMigration()
                            .build()
                    INSTANCE = instance
                }
                 return instance
            }
        }
    }
}
