package at.htl.leonding.swimresults.database

import androidx.lifecycle.LiveData
import androidx.room.*

@Dao
interface SwimResultsDao {

    @Insert
    fun insertSwimmer(swimmer: Swimmer)

    @Delete
    fun deleteSwimmer(swimmer: Swimmer)

    @Update
    fun updateSwimmer(swimmer: Swimmer)

    @Query("SELECT * from swimmers ORDER BY lastName, firstName")
    fun getAllSwimmers(): LiveData<List<Swimmer>>

    @Query("SELECT * from swimmers WHERE swimmerId = :key")
    fun getSwimmer(key: Long): Swimmer?

}

