package at.htl.leonding.swimresults.editswimmer

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.databinding.DataBindingUtil
import androidx.fragment.app.Fragment
import androidx.lifecycle.Observer
import androidx.lifecycle.ViewModelProviders
import androidx.navigation.fragment.findNavController
import at.htl.leonding.swimresults.R
import at.htl.leonding.swimresults.database.SwimResultsDatabase


class EditSwimmerFragment : Fragment() {

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?,
                              savedInstanceState: Bundle?): View? {

        val binding : at.htl.leonding.swimresults.databinding.FragmentEditSwimmerBinding = DataBindingUtil
                .inflate(inflater, R.layout.fragment_edit_swimmer, container, false)
        binding.lifecycleOwner = this

        val application = requireNotNull(this.activity).application
        val args = EditSwimmerFragmentArgs.fromBundle(arguments!!)

        val viewModelFactory = EditSwimmerViewModelFactory(args.swimmerId, application)
        val swimmerManagerViewModel =
                ViewModelProviders.of(
                        this, viewModelFactory).get(EditSwimmerViewModel::class.java)


        swimmerManagerViewModel.navigateBack.observe(this, Observer{
            it?.let{
                if (it){
                    navigateBack()
                    swimmerManagerViewModel.doneNavigating()
                }
            }
        })

        binding.editSwimmerViewModel = swimmerManagerViewModel

        return binding.root
    }

    private fun navigateBack() {
        this.findNavController()
                .navigate(EditSwimmerFragmentDirections
                        .actionEditSwimmerFragmentToSwimmerListFragment())
    }


    companion object {
        val LOG_TAG = EditSwimmerFragment::class.java.simpleName
    }
}
