package at.htl.leonding.swimresults.swimmerlist

import android.os.Bundle
import android.view.*
import androidx.databinding.DataBindingUtil
import androidx.fragment.app.Fragment

import androidx.lifecycle.Observer
import androidx.lifecycle.ViewModelProviders
import androidx.navigation.fragment.findNavController
import androidx.recyclerview.widget.LinearLayoutManager
import at.htl.leonding.swimresults.R

class SwimmerListFragment : Fragment() {

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?,
                              savedInstanceState: Bundle?): View? {

        val binding: at.htl.leonding.swimresults.databinding.FragmentSwimmerListBinding = DataBindingUtil.inflate(
                inflater, R.layout.fragment_swimmer_list, container, false)

        val swimmerListViewModel =
                ViewModelProviders.of(this)
                        .get(SwimmerListViewModel::class.java)

        binding.swimmerListViewModel = swimmerListViewModel
        binding.rvSwimmers.layoutManager = LinearLayoutManager(this.context)
        binding.rvSwimmers.setHasFixedSize(true)
        val adapter = SwimmersAdapter()
        binding.rvSwimmers.adapter = adapter

        swimmerListViewModel.swimmers.observe(this, Observer{
            it?.let{
                adapter.setSwimmers(it)
            }
        })

        adapter.deleteCallBack = {
            swimmerListViewModel.delete(it)
        }
        adapter.updateCallBack = {

            this.findNavController()
                    .navigate(SwimmerListFragmentDirections
                            .actionSwimmerListFragmentToEditSwimmerFragment(it.swimmerId))
        }

        setHasOptionsMenu(true)

        return binding.root
    }

    override fun onCreateOptionsMenu(menu: Menu?, inflater: MenuInflater?) {
        inflater?.inflate(R.menu.menu_swimmer_list,menu!!)
    }

    override fun onOptionsItemSelected(item: MenuItem?): Boolean {
        return when(item?.itemId){
            R.id.menu_item_add -> {
                addSwimmer()
                true
            }
            else -> false
        }
    }

    private fun addSwimmer() {
        this.findNavController()
                .navigate(SwimmerListFragmentDirections
                        .actionSwimmerListFragmentToEditSwimmerFragment(0L))

    }

}
