package at.htl.leonding.swimresults.swimmerlist

import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import at.htl.leonding.swimresults.R
import at.htl.leonding.swimresults.database.Swimmer
import kotlinx.android.synthetic.main.swimmer_card.view.*

class SwimmersAdapter : RecyclerView.Adapter<SwimmersAdapter.SwimmerViewHolder>() {

    private var _swimmers : List<Swimmer> = mutableListOf()

    fun setSwimmers(swimmers: List<Swimmer>) {
        _swimmers = swimmers
        notifyDataSetChanged()
    }

    lateinit var deleteCallBack: (note: Swimmer) -> Unit
    lateinit var updateCallBack: (note: Swimmer) -> Unit

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): SwimmerViewHolder {
        val layout = LayoutInflater.from(parent.context).inflate(R.layout.swimmer_card, parent, false)
        return SwimmerViewHolder(layout)
    }

    override fun getItemCount() = _swimmers.size

    override fun onBindViewHolder(holder: SwimmerViewHolder, position: Int) {
        val swimmer = _swimmers[position]
        with(holder.card){
            tvName.text = "${swimmer.lastName.toUpperCase()} ${swimmer.firstName} (${swimmer.ageGroup})"
            tvOsvId.text = "${swimmer.swimmerId}"
            tvClub.text = "${swimmer.club}"
            if (swimmer.isMale){
                ivGender.setImageResource(R.drawable.man)
            }
            else{
                ivGender.setImageResource(R.drawable.woman)
            }
            ivDelete.setOnClickListener{
                deleteCallBack(swimmer)
            }
            setOnClickListener{
                updateCallBack(swimmer)
            }
        }
    }

    class SwimmerViewHolder(var card: View) : RecyclerView.ViewHolder(card) {
    }

}
